#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"
#include "maze.h"

#define SCREEN_WIDTH    (MAZE_WIDTH  * TILE_SIZE + WALL_WIDTH)
#define SCREEN_HEIGHT   (MAZE_HEIGHT * TILE_SIZE + WALL_WIDTH)

CMaze maze;

// choose a random wall inside maze
STile* chooseWall(bool& isHorizontal)
{
    int x, y;
    isHorizontal = (rand() & 1 ? false : true);

    if (isHorizontal == true)
    {
        x = 1 + (rand() % (MAZE_WIDTH - 2));
        y = 1 + (rand() % (MAZE_HEIGHT - 1));
    }
    else
    {
        x = 1 + (rand() % (MAZE_WIDTH - 1));
        y = 1 + (rand() % (MAZE_HEIGHT - 2));
    }

    return maze.getTile(x, y);
}

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Tree Maze 5", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0));

    // main loop
    while (sys.isQuitRequested() == false)
    {
        bool isHorizontal;
        STile*  tile = chooseWall(isHorizontal);

/*
        if (isHorizontal == true)
        {
            tile->topIsActive = true;
            tile->topColor = Color(255, 0, 0);
        }
        else
        {
            tile->leftIsActive = true;
            tile->leftColor = Color(0, 255, 0);
        }
*/
        maze.draw();

        sys.processEvents();
        gfx.render();
        sys.wait(50);
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
